# Infinity

[![CodeFactor](https://www.codefactor.io/repository/github/knezzz/break_infinity/badge?s=6ff5ffd372b8e0e7ea56c4914eb666bcd9a8a88b)](https://www.codefactor.io/repository/github/knezzz/break_infinity)

## Big number library for dart
Numbers range:
10^-(10^^1e308) - 10^^1e308

This library is meant for idle/clicker games where numbers go really high and precision is not that important
 
Inspiration and idea for this came from [Patashu's break eternity](https://github.com/Patashu/break_eternity.js). 

Usage:

Going past infinity
```dart
Infinity _doubleInfinity = Infinity.fromNum(double.maxFinite);
Infinity _result = _doubleInfinity ^ _doubleInfinity;
print(_result);
```
> prints: ee310.74362528890225

Most operators are usable, and can be mixed with normal numbers:

```dart
// Infinity is at 1.7976931348623157e+308 so 1e310 is too big for double
Infinity _reallyBigNumber = Infinity.fromString('1e310');

Infinity _result = _reallyBigNumber / 2;
print(_result);
```
> prints: 5.0e309