library infinity;

import 'dart:math' as math;

import 'package:infinity/infinity/logger.dart';

part 'infinity/_internal/_egg.dart';

/// Internal stuff
part 'infinity/_internal/add_layer.dart';
part 'infinity/_internal/from_string_handlers.dart';

/// Abbreviations
part 'infinity/abbreviations/abs.dart';
part 'infinity/abbreviations/clamp.dart';
part 'infinity/abbreviations/gamma.dart';
part 'infinity/abbreviations/negate.dart';
part 'infinity/abbreviations/reciprocal.dart';
part 'infinity/abbreviations/round.dart';

/// Comparison
part 'infinity/comparison/comparison.dart';

/// Functions
part 'infinity/functions/exponential.dart';
part 'infinity/functions/factorial.dart';
part 'infinity/functions/lambert.dart';
part 'infinity/functions/logarithm.dart';
part 'infinity/functions/trigonometry.dart';

/// Infinity
part 'infinity/infinity.dart';
part 'infinity/infinity_constants.dart';

/// Operators
part 'infinity/operators/add.dart';
part 'infinity/operators/divide.dart';
part 'infinity/operators/log.dart';
part 'infinity/operators/modulo.dart';
part 'infinity/operators/multiply.dart';
part 'infinity/operators/pentate.dart';
part 'infinity/operators/pow.dart';
part 'infinity/operators/root.dart';
part 'infinity/operators/subtract.dart';
part 'infinity/operators/tetrate.dart';
